%Eestimate_rules. Estimates policy rules for theory paper

clear all
close all
addpath //Users/johncochrane/Dropbox/JC_matlab
%addpath //Users/fjcochra/Dropbox/JC_matlab


% note: options are mostly historical. Ony do_bs has been checked with
% latest program. 
tex_files = 1; % print tables to files
stdate = 1947; % choose sample. Growth rates start 1 period later. 1929 is min. Note other than 1947 will over write tables. 
enddate = 2018; % < 2018 look at old sample with new data
old_data = 0; % allows you to rerun with old data -- just to debug strange results with new data. NOT IMPLEMENTED CORRECTLY YET

use_consumption = 1; 
get_data_and_run_var; % common script with value_decomposition

% do again to get standard errors 
 
[bv,sebv,R2v,R2vadj,v,F] = olsgmm(x1,x,1,0);
fprintf('\\begin{table}[htbp] \n');
fprintf('\\begin{center}\n');
fprintf('\\begin{tabular}{rccccccccc} \n'); 
fprintf('          & $s_t$ & $v_t$ & $\\pi_t$ & $g_t$ & $r^n_t$ & $i_t$ & $y_t$ & $\\sigma(\\varepsilon)$ & $\\sigma(s)$ \\\\ \\hline \n'); 
fprintf(' VAR $s_{t+1}=$&  %2.2f &  %3.3f  &  %2.2f  &  %2.2f  &  %2.2f  &  %2.2f  &  %2.2f   &  %2.2f   &  %2.2f  \\\\ \n',...
    bv([svi vi pii gi rni yi y10i]+1,svi),100*std(err(:,svi)),100*std(xl(:,svi)));
fprintf('  std. err. & (%2.2f) & (%3.3f) & (%2.2f) & (%2.2f) & (%2.2f) & (%2.2f)& (%2.2f) & & \\\\  \n',sebv([svi vi pii gi rni yi y10i]+1,svi));
fprintf(' $v_{t+1}=$&  %2.2f &  %2.2f  &  %2.2f  &  %2.2f  &  %2.2f  &  %2.2f  &  %2.2f  &  &  \\\\ \n',bv([svi vi pii gi rni yi y10i]+1,vi));
fprintf('  std. err. & (%2.2f) & (%2.2f) & (%2.2f) & (%2.2f) & (%2.2f) & (%2.2f)& (%2.2f) & &  \\\\ \\hline \n',sebv([svi vi pii gi rni yi y10i]+1,vi));


H = 1000;
N = size(x,2)-1;
xts1 = zeros(H,N); % holds impulse response

b2s1 = [err(:,svi)]\err; % shock to surplus
xts1(2,:) = -b2s1';
for indx = 3:H; % find impulse response function
    xts1(indx,:) = xts1(indx-1,:)*A';
end;
[sumwpi_s1,sum1wpi_s1,sum1wrnpi_s1,sum1mwrnpi_s1,infl_s1,rn_s1,sums_s1,sumg_s1,sumrpi_s1,omeg_s1] =...
    decode(find_decomp(xts1,pii,rni,gi,svi));


% simple VAR of just surplus and debt
xs = [ svt_x(stind:end) vt(stind:end)];
xs1 = xs(2:end,:);
xs = [ones(size(xs,1)-1,1) xs(1:end-1,:)];

%bs = xs\xs1; % Estimate by OLS

[bs,sebs,R2s,R2vadj,v,F] = olsgmm(xs1,xs,1,0);
errs = xs1-xs*bs;
fprintf(' Small VAR $s_{t+1}=$&  %2.2f &  %3.3f   &   &    & &  &  &  %2.2f & %2.2f \\\\\n',...
    bs(2:end,1),100*std(errs(:,1)),100*std(svt_x(stind:end)));
fprintf('         std. err.    & (%2.2f) &  (%3.3f) &   &  &  &  &  &  & \\\\ \n',sebs(2:end,1));
fprintf('           $v_{t+1}=$ &  %2.2f  &  %2.2f   &   &  &  &  &  &  &   \\\\\n',bs(2:end,2));
fprintf('           std. err.  & (%2.2f) & (%2.2f)  &   &  &  &  &  &  &  \\\\  \\hline \n',sebs(2:end,2));

As = bs(2:end,:)';

xts2 = zeros(H,2); % holds impulse response
b2s2 = [errs(:,1)]\errs; % shock to gdp and inlation
xts2(2,:) = -b2s2';
for indx = 3:H; % find impulse response function
    xts2(indx,:) = xts2(indx-1,:)*As';
end;


% univariate 
xsu = [ svt_x(stind:end) ];
xsu1 = xsu(2:end,:);
xsu = [ones(size(xsu,1)-1,1) xsu(1:end-1,:)];

%bsu = xsu\xsu1; % Estimate by OLS
[bsu,sebsu,R2su,R2vadj,v,F] = olsgmm(xsu1,xsu,1,0);
errsu = xsu1-xsu*bsu;
fprintf(' AR(1) $s_{t+1}=$ &  %2.2f &     &   &    &   &  & & %2.2f & %2.2f  \\\\\n',...
    bsu(2:end,1),100*std(errsu),100*std(svt_x(stind:end)));
fprintf('        std. err.  & (%2.2f) &    &   &    &   &   & &    \\\\\n',sebsu(2:end,1));
fprintf('\\end{tabular} \n'); 
fprintf(['\\caption{Surplus forecasting regressions. Variables are $s=$ surplus, $v=$ debt/GDP, $\\pi$ = inflation,'...
                  ' $g=$ growth, $i=$ 3 month rate, $y=$ 10 year yield. Sample 1947-2018.}\\label{svar}\n']); 
fprintf('\\end{center} \n');
fprintf('\\end{table} \n');

errsu = xsu1-xsu*bsu;
Asu = bsu(2:end,:)';

xtsu2 = zeros(H,1); % holds impulse response

xtsu2(2,:) = -1;
for indx = 3:H; % find impulse response function
    xtsu2(indx,:) = xtsu2(indx-1,:)*Asu';
end;


fprintf('\\begin{table}[hbtp] \n'); 
fprintf('\\begin{tabular}{r cccc}  \n'); 
fprintf('  &  $\\sum_{j=0}^{\\infty} s_{1+j} $ %% \n') 
fprintf('  &  $+\\sum_{j=0}^{\\infty} \\omega^j \\pi_{1+j}$ %% \n');
fprintf('  &  $+\\sum_{j=0}^{\\infty} g_{1+j}$ %% \n'); 
fprintf('  & $-\\sum_{j=1}^{\\infty} (1-\\omega^j) (r^n_{1+j}-\\pi_{1+j})=0$ \\\\ \\hline \n');
        
fprintf('         VAR & %2.2f & %2.2f & %2.2f & -(%2.2f) $=0$ \\\\\n',sums_s1,sumwpi_s1,sumg_s1,sum1mwrnpi_s1 );
fprintf(' Small VAR & %2.2f & & & \\\\\n',sum(xts2(:,1))); 
fprintf('      AR(1) & %2.2f & & & \\\\\n',sum(xtsu2(:,1)));
fprintf('\\end{tabular} \n'); 
fprintf('\\caption{Decomposition of debt repayment, in response to a 1\\%% defifcit shock.}\\label{decomp} \n'); 
fprintf('\\end{table}\n'); 



% picture

if 0
    fig_ir2 = figure;
    colors = get(fig_ir2,'defaultaxescolororder');
    plot((0:H-1)',xts1(:,[svi gi]) ,'linewidth',2);
    hold on
    %plot((0:H-1)',xts1(:,[ vi ]) ,'linewidth',2);
    plot((0:H-1)',([1; omeg_s1.^(0:1:H-2)']).*xts1(:,pii) ,'linewidth',2);
    plot((2:H-1)',(1-omeg_s1.^(1:1:H-2)').*(xts1(3:end,rni)-xts1(3:end,pii)) ,'linewidth',2);
    plot((0:H-1)',xts2(:,1) ,'--','linewidth',2);
    plot((0:H-1)',xtsu2(:,1) ,'-v','linewidth',2);
    plot((0:H-1)',zeros(H,1),'-k');
    text(1.2,xts1(2,svi),'s','fontsize',16,'color',colors(1,:));
    text(1,xts1(2,pii)+0.03,'\pi','fontsize',16,'color',colors(3,:));
    text(1,xts1(2,gi)-0.02,'g','fontsize',16,'color',colors(2,:));
    text(3,0.07,'r^n-\pi','fontsize',16,'color',colors(4,:));
    %text(6.3,xts1(6+1,vi),lbls(vi),'color',colors(3,:),'fontsize',16);
    %text(5,xts1(5+1,svi)+0.07,[char(lbls(svi)) ', \Sigma=' num2str(sums_s1,'%4.2f')],'color',colors(1,:),'fontsize',16);
    axis([0 15 -1.1 0.2]);
    xlabel('Years')
    ylabel('Percent')
    legend('surplus','growth','\omega^j \pi_j','(1-\omega^j) (r^n_j-\pi_j)','surplus, simple VAR','surplus, AR(1)','location','best')
end


fig_ir2 = figure;
colors = get(fig_ir2,'defaultaxescolororder');
plot((0:H-1)',xts1(:,[svi vi]) ,'linewidth',2);
hold on
plot((0:H-1)',xts2(:,1) ,'--','linewidth',2);
plot((0:H-1)',xtsu2(:,1) ,'-v','linewidth',2);
plot((0:H-1)',zeros(H,1),'-k');
text(1.2,xts1(2,svi),'s','fontsize',16,'color',colors(1,:));
text(1.3,xts1(1+1,vi),lbls(vi),'color',colors(2,:),'fontsize',16);
text(5,xts1(5+1,svi)+0.15,[char(lbls(svi)) ', \Sigma=' num2str(sums_s1,'%4.2f')],'color',colors(1,:),'fontsize',16);
text(6,xtsu2(6+1)-0.1,[char(lbls(svi)) ', \Sigma=' num2str(sum(xtsu2),'%4.2f')],'color',colors(4,:),'fontsize',16);

axis([0 15 -inf inf]);
xlabel('Years')
ylabel('Percent')
legend('surplus','debt',['surplus, simple VAR, \Sigma=' num2str(sum(xts2(:,1)),'%2.2f')],'surplus, AR(1)','location','best')
print -depsc2 sandv.eps



% add gdp gap

x = load('data/GDPPOT.csv');
eni = find((x(:,1)==2018)&(x(:,2) == 10));
gdppot = x(1:eni,4); %1949-2018

x = load('data/GDPc1.csv');
sti = find((x(:,1)==1949)&(x(:,2) == 1));
eni = find((x(:,1)==2018)&(x(:,2) == 10));
gdp = x(sti:eni,4);

gap = log(gdp)-log(gdppot); 
gap = gap(4:4:end,:);


% run surplus and interest policy rules 
%lbls = {'r^n','g', '\pi','s','v','i','y'};

fprintf('\\begin{table}[htb] \n');
fprintf('\\begin{center} \n');
fprintf('\\begin{tabular}{rccccc}\n');
fprintf(' & \\multicolumn{4}{c}{$i_t = a + \\rho i_{t-1} + b x_t + c \\pi_t + u_{i,t} $} \\\\ \n');
fprintf('  & $\\rho$ & $b$  & $c$ & $\\rho_u$ & $R^2$ \\\\ \n');
fprintf('\\hline  \n');

 x = [ones(size(xl,1)-2,1) gap xl(3:end,pii)];
 [bv,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,yi),x,4,1);
 err = xl(3:end,yi)-x*bv;
 rhoi = err(1:end-1)\err(2:end);
fprintf('        OLS  &  %2.2s &  %2.2f  &  %2.2f  & %2.2f & %2.2f \\\\ \n',' ', bv(2:end),rhoi, R2v);
fprintf('        s.e. &  %2.2s & (%2.2f) & (%2.2f) & %5.2s & %2.2s \\\\\n', ' ', sebv(2:end),' ', ' ');


 x1 = [ones(size(xl,1)-2,1) gap ];
 [bv,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,yi),x1,4,1);
 err = xl(3:end,yi)-x1*bv;
 rhoi = err(1:end-1)\err(2:end);
fprintf(' Single  OLS  &  %2.2s &  %2.2f  &  %2.2s  & %2.2f & %2.2f \\\\ \n',' ', bv(2:end),' ',rhoi, R2v);
fprintf('        s.e. &  %2.2s & (%2.2f) & %5.2s & %5.2s & %2.2s \\\\\n', ' ', sebv(2:end),' ',' ', ' ');

 x1 = [ones(size(xl,1)-2,1)  xl(3:end,pii)];
 [bv,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,yi),x1,4,1);
 err = xl(3:end,yi)-x1*bv;
 rhoi = err(1:end-1)\err(2:end);
fprintf('Single OLS  &  %2.2s &  %5.2s  &  %2.2f  & %2.2f & %2.2f \\\\ \n',' ',' ', bv(2:end),rhoi, R2v);
fprintf('        s.e. &  %2.2s &  %5.2s  & (%2.2f) & %5.2s & %2.2s \\\\\n', ' ', ' ',sebv(2:end),' ', ' ');

 x3 = [ones(size(xl,1)-3,1) gap(2:end)-rhoi*gap(1:end-1) xl(4:end,pii)-rhoi*xl(3:end-1,pii)];
 [bv3,sebv,R2v,R2vadj,v,F] = olsgmm((xl(4:end,yi)-rhoi*xl(3:end-1,yi)),x3,4,1);
 fprintf(' $1-\\rho L$   &  %2.2s &  %2.2f  &  %2.2f  & %5.2s & %2.2f \\\\ \n',' ',bv3(2:end),' ', R2v);
 fprintf('        s.e. &  %2.2s & (%2.2f) & (%2.2f) & %5.2s & %2.2s \\\\\n',' ',sebv(2:end),' ', ' ');
 
 x2 = [ones(size(xl,1)-2,1) xl(2:end-1,yi) gap xl(3:end,pii)];
 b2 = x2\xl(3:end,yi);
 [b2,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,yi),x2,4,1);
  err = xl(3:end,yi)-x2*b2;
 rhoi = err(1:end-1)\err(2:end);
 
 fprintf(' With lag   &  %2.2f &  %2.2f  &  %2.2f  & %2.2f & %2.2f \\\\ \n', b2(2:end),rhoi, R2v);
 fprintf('       s.e. &  (%2.2f) & (%2.2f) & (%2.2f) & %5.2s & %2.2s \\\\\n', sebv(2:end),' ', ' ');
 fprintf(' $b/(1-\\rho)$   &  %2.2s &  %2.2f  &  %2.2f  & %2.2s & %2.2s \\\\ \n',' ', b2(3:end)/(1-b2(2)),' ',' ');

 figure 
 hold on;
 plot(1948+(1:1:70)',[ 100*xl(3:end,yi) ],'-vb','linewidth',2)
 plot(1948+(1:1:70)',[ 100*gap ],'--k','linewidth',2)
 plot(1948+(1:1:70)',[ 100*xl(3:end,pii)],'-r','linewidth',2)
 
 legend('interest rate','gap','inflation');
 axis([1948 2018 -inf inf])
 print -depsc2 igappi.eps;

 % s regressions
 
 fprintf('\\hline \n');
 fprintf(' & \\multicolumn{4}{c}{$s_t = a + \\rho s_{t-1} + b x_t + c \\pi_t + u_{s,t} $} \\\\ \n');
 fprintf('  & $\\rho$ & $b$  & $c$ & $\\rho_u$ & $R^2$ \\\\ \n');
fprintf('\\hline \n');
 

 [bv,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,svi),x,4,1);
 err = xl(3:end,svi)-x*bv;
 rhos = err(1:end-1)\err(2:end);
 fprintf('        OLS  &  %2.2s &  %2.2f  &  %2.2f  & %2.2f & %2.2f \\\\ \n',' ', bv(2:end),rhos, R2v);
 fprintf('        s.e. &  %2.2s & (%2.2f) & (%2.2f) & %5.2s & %2.2s \\\\\n', ' ', sebv(2:end),' ', ' ');

   x1 = [ones(size(xl,1)-2,1) gap ];
 [bv,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,svi),x1,4,1);
 err = xl(3:end,svi)-x1*bv;
 rhoi = err(1:end-1)\err(2:end);
fprintf(' Single OLS  &  %2.2s &  %2.2f  &  %2.2s  & %2.2f & %2.2f \\\\ \n',' ', bv(2:end),' ',rhoi, R2v);
fprintf('        s.e. &  %2.2s & (%2.2f) & %5.2s & %5.2s & %2.2s \\\\\n', ' ', sebv(2:end),' ',' ', ' ');

 x1 = [ones(size(xl,1)-2,1)  xl(3:end,pii)];
 [bv,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,svi),x1,4,1);
 err = xl(3:end,svi)-x1*bv;
 rhoi = err(1:end-1)\err(2:end);
fprintf(' Single OLS  &  %2.2s &  %5.2s  &  %2.2f  & %2.2f & %2.2f \\\\ \n',' ',' ', bv(2:end),rhoi, R2v);
fprintf('        s.e. &  %2.2s &  %5.2s  & (%2.2f) & %5.2s & %2.2s \\\\\n', ' ', ' ',sebv(2:end),' ', ' ');


 x3 = [ones(size(xl,1)-3,1) gap(2:end)-rhos*gap(1:end-1) xl(4:end,pii)-rhos*xl(3:end-1,pii)];
 [bv3,sebv,R2v,R2vadj,v,F] = olsgmm((xl(4:end,svi)-rhos*xl(3:end-1,svi)),x3,4,1);
 fprintf(' $1-\\rho L$   &  %2.2s &  %2.2f  &  %2.2f  & %5.2s & %2.2f \\\\ \n',' ',bv3(2:end),' ', R2v);
 fprintf('        s.e. &  %2.2s & (%2.2f) & (%2.2f) & %5.2s & %2.2s \\\\\n',' ',sebv(2:end),' ', ' ');
 
 x2 = [ones(size(xl,1)-2,1) xl(2:end-1,svi) gap xl(3:end,pii)];
 b2 = x2\xl(3:end,svi);
 [b2,sebv,R2v,R2vadj,v,F] = olsgmm(xl(3:end,svi),x2,4,1);
  err = xl(3:end,svi)-x2*b2;
 rhos = err(1:end-1)\err(2:end);
 
 fprintf(' With lag   &  %2.2f &  %2.2f  &  %2.2f  & %2.2f & %2.2f \\\\ \n', b2(2:end),rhos, R2v);
 fprintf('       s.e. &  (%2.2f) & (%2.2f) & (%2.2f) & %5.2s & %2.2s \\\\\n', sebv(2:end),' ', ' ');
 fprintf(' $b/(1-\\rho)$   &  %2.2s &  %2.2f  &  %2.2f  & %2.2s & %2.2s \\\\ \n',' ', b2(3:end)/(1-b2(2)),' ',' '); 
 
 fprintf('\\end{tabular} \n');
 fprintf('\\caption{Policy rule regressions. $i$= interest rate, $x$ = GDP gap, $s$ = surplus. Sample 1949-2018.}\\label{rules} \n');
 fprintf('\\end{center} \n');
 fprintf('\\end{table} \n');
 
 figure 
 hold on
 plot(1948+(1:1:70)',[ 100*xl(3:end,svi) ],'-v','linewidth',2)
 plot(1948+(1:1:70)',[  100*gap ],'--k','linewidth',2)
 plot(1948+(1:1:70)',[ 100*xl(3:end,pii)],'-r','linewidth',2)
legend('surplus','gap','inflation');
 axis([1948 2018 -inf inf])
print -depsc2 sruledata.eps; 




function  dt = find_decomp(xt,pii,rni,gi,svi);

fun = @(omeg) (xt(2,rni)+sum( (omeg.^(1:size(xt,1)-2)').*xt(3:end,rni))).^2;
options = optimoptions('fmincon','Display','off');
omeg = fmincon(fun,0.7,[],[],[],[],0,1,[],options);
fval = fun(omeg);
if fval > 1e-8;
    disp('omega search was not able to nail identity, usig closest omega, and error = '); 
    disp([omeg fval^0.5]);
end

sumwpi = sum( (omeg.^(0:size(xt,1)-2)').*xt(2:end,pii));
sum1wpi  = sum( (omeg.^(1:size(xt,1)-2)').*xt(3:end,pii));
sum1wrnpi = sum( (omeg.^(1:size(xt,1)-2)').*(xt(3:end,rni)-xt(3:end,pii)));
sum1mwrnpi = sum( (1-omeg.^(1:size(xt,1)-2)').*(xt(3:end,rni)-xt(3:end,pii)));

infl = xt(2,pii);
rn = xt(2,rni);
sums = sum(xt(2:end,svi));
sumg = sum(xt(2:end,gi));
sumrpi = sum(xt(3:end,rni)-xt(3:end,pii));
dt = [sumwpi sum1wpi sum1wrnpi sum1mwrnpi infl rn sums sumg sumrpi omeg];

end

function [sumwpi,sum1wpi,sum1wrnpi,sum1mwrnpi,infl,rn,sums,sumg,sumrpi,omeg] = decode(dt);
sumwpi = dt(1);
sum1wpi = dt(2);
sum1wrnpi = dt(3);
sum1mwrnpi = dt(4);
infl = dt(5);
rn = dt(6);
sums = dt(7);
sumg = dt(8);
sumrpi = dt(9);
omeg = dt(10);
end



 