cormat = corr(err);
if tex_files & (stdate==1947);
    disp('printing correlation matrix of shocks  and b2 to file')
    cormat_ID=fopen('cormat.tex','w');
elseif tex_files & (stdate==1930);
    disp('printing correlation matrix of shocks  and b2 to file')
    cormat_ID=fopen('cormat_30.tex','w');
elseif tex_files & (stdate==1980);
    disp('printing correlation matrix of shocks  and b2 to file')
    cormat_ID=fopen('cormat_80.tex','w');
else
    cormat_ID = 1; 
end


% print b2

fprintf(cormat_ID,'\\begin{table} \n');
fprintf(cormat_ID,'\\begin{center} \n');
fprintf(cormat_ID,['\\begin{tabular}{r|' char('c'*ones(1,N)) '} \n']);
fprintf(cormat_ID,' %12.12s &',  ' ' );
for indx = 1:size(lbls,2)-1
    fprintf(cormat_ID,' %12.12s & ',  ['$' char(lbls(indx)) '$']);
end;
fprintf(cormat_ID,' %12.12s \\\\ \n',  ['$' char(lbls(end)) '$']);
fprintf(cormat_ID,'\\hline\n');
fprintf(cormat_ID,'  & \\multicolumn{6}{c}{Regression of other shocks on inflation shock} \\\\ \n');
fprintf(cormat_ID,'\\hline \n');
fprintf(cormat_ID,' Coefficient ');
fprintf(cormat_ID,' & %8.2f ', b2);
fprintf(cormat_ID,'\\\\ \n');

fprintf(cormat_ID,' Std. err. ');
fprintf(cormat_ID,' & (%2.2f) ', xt_se(1:N,2));
fprintf(cormat_ID,'\\\\ \n');

fprintf(cormat_ID,'\\hline\n');
fprintf(cormat_ID,'& \\multicolumn{6}{c}{Correlation matrix of VAR shocks} \\\\\n');
fprintf(cormat_ID,'\\hline\n');

for indx1 = 1:size(lbls,2);
    fprintf(cormat_ID,' %12.12s  ', ['$' char(lbls(indx1)) '$' ]);
    for indx2 = 1:N;
        fprintf(cormat_ID,' & %2.2f', cormat(indx1,indx2));
    end
    fprintf(cormat_ID,'\\\\\n');
end;

fprintf(cormat_ID,'\\end{tabular}\n');
if stdate == 1947;
    fprintf(cormat_ID,'\\caption{Regression of other shocks on inflation shock, and correlation matrix of VAR shocks}\\label{cormat} \n');
end;
if (stdate == 1930);
    fprintf(cormat_ID,'\\caption{Regression of other shocks on inflation shock, and correlation matrix of VAR shocks}\\label{cormat_30} \n');
end;
if (stdate == 1980);
    fprintf(cormat_ID,'\\caption{Regression of other shocks on inflation shock, and correlation matrix of VAR shocks}\\label{cormat_80} \n');
end;

fprintf(cormat_ID,'\\end{center} \n');
fprintf(cormat_ID,'\\end{table}\n');
fprintf(cormat_ID,' \n');

if tex_files;
    fclose(cormat_ID);
end;
