function f_printvar(ID,b,bse,sigma,R2,R2se,lbls,texlabel,caption, pii) % prints VAR estimates

N = size(b,2);
%fprintf(ID,'\\begin{table} \n');
fprintf(ID,'\\begin{center} \n');
fprintf(ID,['\\begin{tabular}{r|' char('c'*ones(1,N)) '} \n']);

fprintf(ID,' %12.12s &',  ' ' );
for indx = 1:size(lbls,2)-1
    fprintf(ID,' %12.12s & ',  ['$' char(lbls(indx)) '_{t+1}$']);
end;
fprintf(ID,' %12.12s \\\\ \n',  ['$' char(lbls(end)) '_{t+1}$']);
fprintf(ID,'\\hline\n');

for indx = 1:size(lbls,2);
    fprintf(ID,' %12.12s  ', ['$' char(lbls(indx)) '_t$' ]);
    for indx2 = 1:N;
        fprintf(ID,' & %2.2f', b(indx+1,indx2));
        if ~(bse==0);
            if abs(b(indx+1,indx2))>=2*bse(indx+1, indx2);
                fprintf(ID,'\\textsuperscript{**} ');
            elseif abs(b(indx+1,indx2))>=bse(indx+1, indx2);
                fprintf(ID,'\\textsuperscript{*} ');
            end;
        end
    end
    fprintf(ID,'\\\\\n');
end;
fprintf(ID,'\\hline\n');

stde = diag(sigma).^0.5;
fprintf(ID,' $100 \\times std(\\varepsilon_{t+1})$ & ');
fprintf(ID,' %12.2f & ', 100*stde(1:end-1));
fprintf(ID,' %12.2f \\\\\n', 100*stde(end));

correpi = sigma(:,pii)./(stde*sigma(pii,pii)^0.5);
fprintf(ID,' Corr $\\varepsilon, \\varepsilon_{\\pi}$ & ');
fprintf(ID,' %12.2f & ', correpi(1:end-1));
fprintf(ID,' %12.2f \\\\\n', correpi(end));

fprintf(ID,' %12.12s  ', '$R^2$');
if ~(R2se == 0);
    for indx2 = 1:N;
        fprintf(ID,' & %2.2f',R2(indx2));
        if abs(R2(indx2))>=R2se(indx2);
            fprintf(ID,'\\textsuperscript{*} ');
        elseif abs(R2(indx2))>=2*R2se(indx2);
            fprintf(ID,'\\textsuperscript{**} ');
        end;
    end
end
fprintf(ID,'  \\\\\n');

%R2 = 1 - var(e)/var(y)
%1-R2 = var(e)/var(y)
%var(y) = var(e)/(1-R2);

stdx = (diag(sigma)./(1-R2')).^0.5;

fprintf(ID,' $100 \\times std(x)$ & ');
fprintf(ID,' %12.2f & ', 100*stdx(1:end-1));
fprintf(ID,' %12.2f \\\\\n', 100*stdx(end));

fprintf(ID,'\\end{tabular}\n');
fprintf(ID,['\\caption{' caption ...
           '  One (two) stars means the estimate is one (two) Monte Carlo standard errors away from  zero. '...
           '}\\label{' texlabel '} \n']);
fprintf(ID,'\\end{center} \n');
%fprintf(ID,'\\end{table}\n');
fprintf(ID,' \n');

% standard errors. turned off in favor of stars. Turn back on if you
% want them.

if 0
    
    fprintf('\\begin{table} \n');
    fprintf('\\begin{center} \n');
    fprintf(['\\begin{tabular}{r|' char('c'*ones(1,N)) '} \n']);
    
    fprintf(' %12.12s &',  ' ' );
    for indx = 1:size(lbls,2)-1
        fprintf(' %12.12s & ',  ['$' char(lbls(indx)) '_{t+1}$']);
    end;
    fprintf(' %12.12s \\\\ \n',  ['$' char(lbls(end)) '_{t+1}$']);
    fprintf('\\hline\n');
    
    for indx = 1:size(lbls,2)
        fprintf(' %12.12s & ', ['$' char(lbls(indx)) '_t$' ]);
        fprintf(' %12.2f & ', bse(indx+1,1:end-1));
        fprintf(' %12.2f \\\\\n', bse(indx+1,end));
    end;
    fprintf('\\hline\n');
    
    if ~(R2se==0);
        fprintf(' %12.12s & ', '$R^2$');
        fprintf(' %12.2f & ', R2se(1:end-1));
        fprintf(' %12.2f \\\\\n', R2se(end));
    end
    
    fprintf('\\end{tabular}\n');
    fprintf('\\caption{VAR standard errors.}\\label{ %10.10s } \n',fname);
    fprintf('\\end{center} \n');
    fprintf('\\end{table}\n')
    fprintf(' \n');
    
end    