% value_decomposition. Fork from inflation_decomposition_4 6/2019 after submission to AER. 
% this pereseves and modifies the value stuff, deletig inflation stuff. If you change data and 
% VAR in the inflatio decomposition, make sure this mirrors change! 

clear all
close all

tex_files = 1; % print tables to files
save_last_bs = 0; % don't wipe out last bs with do_bs = 1. Use to explore estimation variations
do_bs = 0; % do estimation, bootstrap/monte carlo? (If 0 loads last values) 
Ntrial = 50000;
stdate = 1947; % 1930 or 1947. choose sample. program doesn't really work for other tvalues -- after checking early sample lots of tables and graphs presume 1947
check_bs = 0; % feeds orginal errors to check monte carlo
small_errs = 0; % tiny shocks. Shows how much variance comes from b2 vs. A 
enddate = 2018; % 2014 lets you use old sample and not old data. 
old_data = 0; % allows you to rerun with old data -- just to debug strange results with new data.
% NEEDS OLD DATA recovery from archive if you want to use it

if do_bs; % redo bootstrap/monte carlo? (or load last one) Now also loads data and runs main VAR.
    %0 to play with plots and tables
        
    get_data_and_run_var;

    W = cov(x1);
    % note W is quite different from ImA*sigma*ImA'. Use W so var(v) is the
    % sample var of v

    % run filtered VAR too
   
%    xf = [rnt(stind-4:end) grt(stind-4:end) inflt(stind-4:end) svt_x(stind-4:end) vt(stind-4:end) y_a(stind-4:end) y10_a(stind_y10-4:end)];
    
    xf = xl(4:end,:)-1/3*(xl(3:end-1,:)+xl(2:end-2,:)+xl(1:end-3,:));
    xfl = xf; % save for later
    x1f = xf(2:end,:);
    xf = [ones(size(xf,1)-1,1) xf(1:end-1,:)];
    bf = xf\x1f;
    errf = x1f-xf*bf;
    sigmaf = cov(errf);
    R2f = 1-var(errf)./var(x1f);
    
    Af = bf(2:end,:)';
    ImAf = inv(eye(size(Af,1))-Af);
    Wf = cov(x1f);
    
    % -------------------------------------
    % calculate response to shocks
    % note: shocks should obey return identity!
    % ---------------------------------
    
    H = 200;
    N = size(x,2)-1;
    xt = zeros(H,N);
    
    % ----------------------------
    % monte carlo standard errors
    % ----------------------------
    
    % save space for MC records
    
    T = size(err,1);
    
    b_mc = zeros(size(b,1), size(b,2), Ntrial);
    R2_mc = zeros(size(R2,2), Ntrial); 
    
    bf_mc = zeros(size(bf,1), size(bf,2), Ntrial);
    R2f_mc = zeros(size(R2f,2), Ntrial); 
    
    covvs = zeros(Ntrial,3);
    covvrg =  zeros(Ntrial,3);
    covvSrn = zeros(Ntrial,3);
    covvSpi = zeros(Ntrial,3);
    covvSr = zeros(Ntrial,3);
    covvSg =  zeros(Ntrial,3);
    sigmav = zeros(Ntrial,3);
    
    
    % following assumes use of sv_x, identity holds exactly so we need to
    % build a singular covaraince matrix. If you use sv, modify
    
    sigma_small = cov(err(:,[rni gi pii vi yi y10i])); % omit s, infer from identity
    C = chol(sigma_small); % C'*C = sigma_small
    
    % hard wired to current variable ordering!
    
    rng(123); % seed random number generator so you get the same answers
    
    nskipped = 0;
    for trial = 1:Ntrial;
        for indx_test=1:1000 ; % sets up a loop for eig < 1
       
            % generate artificial data
            err_small = randn(T,6)*C; % generate errors
            err_s_implied = err_small*[1 -1 -1 -1 0 0]';
            err_t = [err_small(:,1:3) err_s_implied err_small(:,4:6)];
            
            if small_errs;
                err_t = err_t/10000;
            end;
            
            if check_bs;
                err_t = err; 
            end;
            
            x_trial(1,:) = x(1,:); % generate artificial data 
            for tim = 2:T+1; % x is one longer than error
                x_trial(tim,:) = [1  x_trial(tim-1,:)*b] + [ 0 err_t(tim-1,:)];
            end;
            
            
            % estimate VAR
            % make sure following code is exactly estimation code. Eventually put
            % estimation code in a function to ensure.
            
            x1_trial = x_trial(2:end,2:end);
            b_trial = x_trial(1:end-1,:)\x1_trial;
            A_trial = b_trial(2:end,:)';
            
            % NOTE mc resamples from underlying VAR and filters. One could
            % resample the filtered VAR directly.
            
            xf_trial = x_trial(:,2:end);
            xf_trial = xf_trial(4:end,:)-1/3*(xf_trial(3:end-1,:)+xf_trial(2:end-2,:)+xf_trial(1:end-3,:));
            x1f_trial = xf_trial(2:end,:);
            xf_trial = [ones(size(xf_trial,1)-1,1) xf_trial(1:end-1,:)];
            bf_trial = xf_trial\x1f_trial;
            Af_trial = bf_trial(2:end,:)'; 
            
            if (max(abs(eig(A_trial))) < 1)|(max(abs(eig(Af_trial))) < 1); % only accept convergent A
                break
            else;
                nskipped = nskipped+1;
            end
            
            
        end % ends test for A<1 loop
        if indx_test>=1000;
            disp('error -- never found A<1')
            stop
        end;
        
        err_trial = x1_trial-x_trial(1:end-1,:)*b_trial;
        sigma_trial = cov(err_trial);
        R2_trial = 1-var(err_trial)./var(x1_trial);
        ImA_trial = inv(eye(size(A,1))-A_trial);
        W_trial = cov(x1_trial);
        
        errf_trial = x1f_trial-xf_trial*bf_trial;
        sigmaf_trial = cov(errf_trial);
        R2f_trial = 1-var(errf_trial)./var(x1f_trial);
        ImAf_trial = inv(eye(size(Af_trial,1))-Af_trial);
        Wf_trial = cov(x1f_trial);
        
        % save trial results
        b_mc(:,:,trial) = [b_trial(1,:);A_trial'];
        R2_mc(:,trial) = R2_trial';
        
        bf_mc(:,:,trial) = [bf_trial(1,:);Af_trial'];
        R2f_mc(:,trial) = R2f_trial';
         
        covvs(trial,:) =  [(asv'*ImA_trial*A_trial*W_trial*av)/(av'*W_trial*av),...
                            (asv'*ImA_trial*A_trial*sigma_trial*av)/(av'*sigma_trial*av),...
                            (asv'*ImAf_trial*Af_trial*Wf_trial*av)/(av'*Wf_trial*av)];
        covvrg(trial,:) =  [-((arn-api-ag)'*ImA_trial*A_trial*W_trial*av)/(av'*W_trial*av),...
                            -((arn-api-ag)'*ImA_trial*A_trial*sigma_trial*av)/(av'*sigma_trial*av),...
                            -((arn-api-ag)'*ImAf_trial*Af_trial*Wf_trial*av)/(av'*Wf_trial*av)];
        covvSrn(trial,:) = [(arn'*ImA_trial*A_trial*W_trial*av)/(av'*W_trial*av),...
                            (arn'*ImA_trial*A_trial*sigma_trial*av)/(av'*sigma_trial*av),...
                            (arn'*ImAf_trial*Af_trial*Wf_trial*av)/(av'*Wf_trial*av)];
        covvSpi(trial,:) = [(api'*ImA_trial*A_trial*W_trial*av)/(av'*W_trial*av),...
                            (api'*ImA_trial*A_trial*sigma_trial*av)/(av'*sigma_trial*av),...
                            (api'*ImAf_trial*Af_trial*Wf_trial*av)/(av'*Wf_trial*av)];
        covvSr(trial,:) = [((arn-api)'*ImA_trial*A_trial*W_trial*av)/(av'*W_trial*av),...
                            ((arn-api)'*ImA_trial*A_trial*sigma_trial*av)/(av'*sigma_trial*av),...
                            ((arn-api)'*ImAf_trial*Af_trial*Wf_trial*av)/(av'*Wf_trial*av)];
        covvSg(trial,:) =  [(ag'*ImA_trial*A_trial*W_trial*av)/(av'*W_trial*av),...
                            (ag'*ImA_trial*A_trial*sigma_trial*av)/(av'*sigma_trial*av),...
                            (ag'*ImAf_trial*Af_trial*Wf_trial*av)/(av'*Wf_trial*av)];
        sigmav(trial,:) =   [(av'*W_trial*av)^0.5 (av'*sigma_trial*av)^0.5 (av'*Wf_trial*av)^0.5];
        
        
    end  % ends monte carlo loop 
   
    
    % standard errors and quantiles
    
    disp('number of skipped draws due to |A|>1 out of')
    disp([nskipped Ntrial])
   
    b_mean = mean(b_mc,3);
    b_se = std(b_mc,0,3);
    
    R2_mean = mean(R2_mc,2)';
    R2_se = std(R2_mc,0,2)';
    
    bf_mean = mean(bf_mc,3);
    bf_se = std(bf_mc,0,3);
    
    R2f_mean = mean(R2f_mc,2)';
    R2f_se = std(R2f_mc,0,2)';
        
    indx25 = floor(Ntrial*0.25)+1; % index of 25th and 75th percentiles. round to make bigger tails
    indx50 = floor((Ntrial)/2);% round median down -- no choice! 
    indx75 = floor(Ntrial*0.75)-1; % symmetrically, round to bigger tails
    
    covvs = sort(covvs);
    covvrg =  sort(covvrg);
    covvSrn = sort(covvSrn);
    covvSpi = sort(covvSpi);
    covvSr = sort(covvSr);
    covvSg =  sort(covvSg);
    sigmav = sort(sigmav);
    
    covvs25 = covvs(indx25,:);
    covvrg25 =  covvrg(indx25,:);
    covvSrn25 = covvSrn(indx25,:);
    covvSpi25 = covvSpi(indx25,:);
    covvSr25 = covvSr(indx25,:);
    covvSg25 =  covvSg(indx25,:);
    sigmav25 = sigmav(indx25,:);
    
    covvs75 = covvs(indx75,:);
    covvrg75 =  covvrg(indx75,:);
    covvSrn75 = covvSrn(indx75,:);
    covvSpi75 = covvSpi(indx75,:);
    covvSr75 = covvSr(indx75,:);
    covvSg75 =  covvSg(indx75,:);
    sigmav75 = sigmav(indx75,:);
    
    
    if (~save_last_bs)&(stdate==1947);
        save do_bs_save_vd;
    end;
    if (~save_last_bs)&(stdate==1930);
        save do_bs_save_vd_30;
    end;
    
    
else % If not new bs, load last one
    if stdate==1947;
        load do_bs_save_vd;
    elseif stdate == 1930;
        load do_bs_save_vd_30;
    end
end;

%%%%%%%%%
% graph and tables
%%%%%%%%%

if stdate == 1947;
    %scale unemployment rate to fit on graph
    bu = [ones(size(yr_a,1)-20,1) un(21:end)]\svt_x(21:end);
    unplot = [ones(size(yr_a,1),1) un]*bu;
    
    % plot surplus
    set(0,'DefaultLegendAutoUpdate','off');
    svlin = figure;
    colors = get(svlin,'defaultaxescolororder');
    plot(datenum(yr_a,12,31) ,[ svt_x] ,'-v','linewidth',2);
    hold on
    plot(datenum(yr_a,12,31),unplot,'linewidth',2)
    plot(datenum(stdate,12,31)*[1;1],[0.3;-0.83],'--k');
    plot(datenum(yr_a,12,31),0*yr_a,'-k');
    %title('Surplus/value ratio')
    legend({'surplus','- unemployment'},'location','southeast')
    recessionplot;
    axis([datenum(1929,21,31) datenum(2020,12,31) -0.65 0.2])
    datetick('x','keeplimits');
    xlabel('Date')
    ylabel('Surplus/value of debt');
    print(svlin,'sv_no_comparison.eps','-depsc');
    
    
    %%%%%%%%%%%%
    % Decomposition of value v
    %%%%%%%%%%%%
    
    svtermt = cumsum([0;svt_x(2:end)]);
    rntermt = cumsum([0;rnt(2:end)]);
    infltermt = cumsum([0;inflt(2:end)]);
    gtermt = cumsum([0;grt(2:end)]);
    
    rgtermt = cumsum([0;rnt(2:end)] - [0;inflt(2:end)] - [0;grt(2:end)]);
    
    fig_back = figure;
    plot(yr_a,vt,'linewidth',2);
    hold on
    plot(yr_a,-svtermt+vt(1),'linewidth',2);
    plot(yr_a,rgtermt+vt(1),'linewidth',2);
    plot(yr_a,rntermt+vt(1),'--','linewidth',2)
    plot(yr_a,-infltermt+vt(1),'--','linewidth',2)
    plot(yr_a,rntermt-infltermt+vt(1),'--','linewidth',2)
    plot(yr_a,-gtermt+vt(1),'--','linewidth',2)
    plot(yr_a,0*yr_a+vt(1),'-k')
    plot(stdate*[1;1],[-5;2],'--k');
    
    %title('Backward looking value decomposition');
    %legend('v','-s','r-g','r^n','\pi','r','g','location','southwest')
    indx = find(yr_a==2000);
    text(yr_a(indx),-svtermt(indx)+vt(1),'-s','color',colors(2,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),rgtermt(indx)+vt(1),'r-g','color',colors(3,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),vt(indx),'v','color',colors(1,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx)+2,-infltermt(indx)+vt(1),'-\pi','color',colors(5,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),rntermt(indx)-infltermt(indx)+vt(1),'r','color',colors(6,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx)-2,-gtermt(indx)+vt(1),'-g','color',colors(7,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),rntermt(indx)+vt(1),'r^n','color',colors(4,:),'fontsize',16,'backgroundcolor','w');
    
    axis([1928 2020 -5 2]);
    xlabel('Date')
    ylabel('Log Scale')
    print(fig_back,'value_decomp_backward.eps','-depsc');
    
    
    % plot ex-post value decomposition
    
    svtermt = cumsum(svt(end:-1:1));
    svtermt = svtermt(end:-1:1);
    svtermt = [svtermt(2:end); 0];
    rgtermt = cumsum(rnt(end:-1:1)-inflt(end:-1:1)-grt(end:-1:1));
    rgtermt = rgtermt(end:-1:1);
    rgtermt = [rgtermt(2:end); 0];% line up vt with st+1 etc.
    
    rntermt = cumsum(rnt(end:-1:1));
    rntermt = rntermt(end:-1:1);
    rntermt = [rntermt(2:end); 0];% line up vt with st+1 etc.
    
    rtermt = cumsum(rnt(end:-1:1)-inflt(end:-1:1));
    rtermt = rtermt(end:-1:1);
    rtermt = [rtermt(2:end); 0];% line up vt with st+1 etc.
    
    gtermt = cumsum(grt(end:-1:1));
    gtermt = gtermt(end:-1:1);
    gtermt = [gtermt(2:end); 0];% line up vt with st+1 etc.
    
    
    infltermt = cumsum(inflt(end:-1:1));
    infltermt = infltermt(end:-1:1);
    infltermt = [infltermt(2:end); 0];% line up vt with st+1 etc.
    
    
    fig_fwd = figure;
    plot(yr_a,(vt),'linewidth',2);
    hold on
    plot(yr_a, (svtermt+vt(end)),'linewidth',2);
    plot(yr_a,(-rgtermt+vt(end)),'linewidth',2);
    plot(yr_a, -rtermt+vt(end),'--','linewidth',2);
    %plot(yr_a, infltermt+vt(end),'--','linewidth',2);
    plot(yr_a, gtermt+vt(end),'--','linewidth',2);
    %plot(yr_a, -rntermt+vt(end),'--','linewidth',2);
    plot(stdate*[1;1],[-5;2],'--k');
    plot(yr_a,0*yr_a+vt(end),'-k')
    %title('Forward looking value decomposition');
    %legend('v','s','g-r')
    indx = find(yr_a==1950);
    text(yr_a(indx),vt(indx),'v','color',colors(1,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),svtermt(indx)+vt(end),'s','color',colors(2,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),-rgtermt(indx)+vt(end),'g-r','color',colors(3,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx-10),-rtermt(indx-10)+vt(end)+0.1,'-r','color',colors(4,:),'fontsize',16,'backgroundcolor','w');
    %text(yr_a(indx+20),infltermt(indx+20)+vt(end),'-\pi','color',colors(5,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),gtermt(indx)+vt(end),'g','color',colors(5,:),'fontsize',16,'backgroundcolor','w');
    %text(yr_a(indx-10),-rntermt(indx-10)+vt(end)+0.1,'-r^n','color',colors(7,:),'fontsize',16,'backgroundcolor','w');
    
    axis([1928 2020 -4 2.5]);
    xlabel('Date')
    ylabel('Log Scale')
    print(fig_fwd,'value_decomp_forward.eps','-depsc');
    
    % plot filtered, innovation v
    vfilter = figure;
    yt = vt(4:end)-1/3*(vt(3:end-1)+vt(2:end-2)+vt(1:end-3));
    plot(datenum(yr_a(4:end),12,31),yt ,'-v','linewidth',1.5);
    hold on;
    plot(datenum(yr_a(stind+1:end),12,31),err*av,'linewidth',2);
    plot(datenum(yr_a(4:end),12,31),0*yr_a(4:end),'-k');
    plot(datenum(yr_a(stind)*[1;1],12,31),[min(yt)-0.1; max(yt)+0.1],'--k');
    recessionplot;
    axis([datenum(1929,12,31) datenum(2020,12,31) -0.4 0.65]);
    datetick('x','keeplimits');
    xlabel('Date')
    ylabel('Log scale')
    
    print(vfilter, 'vfilter.eps','-depsc');
    
end

%%%%%%%%%%%%%%%%
% variance decomposition of v
%%%%%%%%%%%%%%%
    

if tex_files;
    disp('writing  VAR  to VAR.tex');
    if stdate == 1947; 
        fname = 'VAR';
        caption = 'VAR estimate. Sample 1947-2018.';
    elseif stdate == 1930
        fname = 'VAR30'; 
        caption = 'VAR estimate. Sample 1930-2018.';
    end
    VAR_ID = fopen([fname '.tex'],'w');
else
    VAR_ID = 1; 
    disp('var'); 
    caption = 'VAR estimate. ';
end
f_printvar(VAR_ID,b,b_se,sigma,R2,R2_se,lbls,fname,caption,pii);
if tex_files
    fclose(VAR_ID);
end;


if tex_files;
    disp('writing filtered VAR  to filteredVAR.tex');
    if stdate == 1947; 
        fname = 'filteredVAR';
        caption = 'Filtered VAR estimate. Variables are the difference to a three year lagged moving average. Sample 1947-2018.';
    elseif stdate == 1930
        fname = 'filteredVAR30'; 
        caption = 'Filtered VAR estimate. Variables are the difference to a three year lagged moving average. Sample 1930-2018.';
    end
    filtVAR_ID = fopen([fname '.tex'],'w');
else
    filtVAR_ID = 1; 
    disp('filtered var'); 
    caption = 'Filtered VAR estimate. Variables are the difference to a three year lagged moving average. ';
end
f_printvar(filtVAR_ID,bf,bf_se,sigma,R2f,R2f_se,lbls,fname,caption,pii);
if tex_files
    fclose(filtVAR_ID);
end;

if tex_files;
    disp('writing v decomposition to vdecomp.tex');
    if stdate == 1947;
        fname = 'vdecomp';
        caption = '\\caption{Decomposition of the variance of the value of debt. Sample 1947-2018. }\\label{vdecomp}';
    elseif stdate == 1930;
        fname = 'vdecomp30';
        caption = '\\caption{Decomposition of the variance of the value of debt. Sample 1930-2018. }\\label{vdecomp30}';
    end
    vdecomp_ID = fopen([fname '.tex'],'w');
else
    vdecomp_ID = 1; 
    caption = '\\caption{Decomposition of the variance of the value of debt.}';
end
%fprintf(vdecomp_ID,'\\begin{table}[htbp] \n');
fprintf(vdecomp_ID,'\\begin{center} \n');
fprintf(vdecomp_ID,'\\begin{tabular}{r|ccc} \n');
fprintf(vdecomp_ID,'   &  \\multicolumn{3}{c}{$(\\cdot)/var(\\tilde{v}_t)$} \\\\ \n')  ;       
fprintf(vdecomp_ID,'%99.99s  & %12.12s & %12.12s & %12.12s \\\\\n','Component','Plain','Innovation','Filtered'); 
fprintf(vdecomp_ID,'\\hline \n');
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', '$var(\tilde{v}_t)$', ...
    (av'*W*av)/(av'*W*av),...
    (av'*sigma*av)/(av'*sigma*av),...
    (av'*Wf*av)/(av'*Wf*av));
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', ' $cov(\tilde{v}_t, \Sigma \tilde{s}_{t+j})$',...
    (asv'*ImA*A*W*av)/(av'*W*av),...
    (asv'*ImA*A*sigma*av)/(av'*sigma*av),...
    (asv'*ImAf*Af*Wf*av)/(av'*Wf*av));
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', '$-cov[\tilde{v}_t, \Sigma (\tilde{r}^n_{t+j}-\tilde{\pi}_{t+j})]$',...
    -((arn-api)'*ImA*A*W*av)/(av'*W*av),...
    -((arn-api)'*ImA*A*sigma*av)/(av'*sigma*av),...
    -((arn-api)'*ImAf*Af*Wf*av)/(av'*Wf*av));
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', '$cov[\tilde{v}_t, \Sigma \tilde{g}_{t+j}]$',...
    ((ag)'*ImA*A*W*av)/(av'*W*av),...
    ((ag)'*ImA*A*sigma*av)/(av'*sigma*av),...
    ((ag)'*ImAf*Af*Wf*av)/(av'*Wf*av));

fprintf(vdecomp_ID,'\\hline \n');
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', ' $-cov(\tilde{v}_t, \Sigma \tilde{r}^n_{t+j})$',...
    -(arn'*ImA*A*W*av)/(av'*W*av),...
    -(arn'*ImA*A*sigma*av)/(av'*sigma*av),...
    -(arn'*ImAf*Af*Wf*av)/(av'*Wf*av));
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', ' $cov(\tilde{v}_t, \Sigma \tilde{\pi}_{t+j})$',...
    (api'*ImA*A*W*av)/(av'*W*av),...
    (api'*ImA*A*sigma*av)/(av'*sigma*av),...
    (api'*ImAf*Af*Wf*av)/(av'*Wf*av));
fprintf(vdecomp_ID,'\\hline \n');
fprintf(vdecomp_ID,'%99.99s & %8.2f & %8.2f & %8.2f \\\\ \n', ' $\sigma(\tilde{v}_t)$',...
    (av'*W*av)^0.5,(av'*sigma*av)^0.5,(av'*Wf*av)^0.5);
fprintf(vdecomp_ID,'\\end{tabular} \n');
%fprintf(vdecomp_ID,[caption ' \n']);
fprintf(vdecomp_ID,'\\end{center} \n');
%fprintf(vdecomp_ID,'\\end{table} \n');

if tex_files
    fclose(vdecomp_ID);
end

if tex_files;
    disp('writing v decomposition quantiles to vdecompq.tex');
    if stdate == 1947;
        fname = 'vdecompq';
        caption = '\\caption{Monte Carlo quantiles for the decomposition of the variance of the value of debt. Sample 1947-2018.}\\label{vdecompq}';
    elseif stdate == 1930;
        fname = 'vdecompq30';
        caption = '\\caption{Monte Carlo quantiles for the decomposition of the variance of the value of debt. Sample 1930-2018.}\\label{vdecompq30}';
    end
    vdecompq_ID = fopen([fname '.tex'],'w');
else
    vdecompq_ID = 1; 
    caption = '\\caption{Monte Carlo quantiles for the decomposition of the variance of the value of debt.}';
end
%fprintf(vdecompq_ID,'\\begin{table}[htbp] \n');
fprintf(vdecompq_ID,'\\begin{center} \n');
fprintf(vdecompq_ID,'\\begin{tabular}{r|cccccc} \n');
fprintf(vdecompq_ID,'   &  \\multicolumn{6}{c}{$(\\cdot)/var(\\tilde{v}_t)$} \\\\ \n')  ;       
fprintf(vdecompq_ID,'%99.99s  & %99.99s & %99.99s & %99.99s \\\\\n','Component',...
                      '\multicolumn{2}{c}{Plain}','\multicolumn{2}{c}{Innovation}','\multicolumn{2}{c}{Filtered}'); 
fprintf(vdecompq_ID,'%99.99s  & %12.12s & %12.12s & %12.12s \\\\\n',' ',...
                      '25\% & 75\%','25\% & 75\%','25\% & 75\%'); 
fprintf(vdecompq_ID,'\\hline \n');

%fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', '$var(\tilde{v}_t)$', ...
 %                   1, 1, 1, 1, 1, 1);
fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', ' $cov(\tilde{v}_t, \Sigma \tilde{s}_{t+j})$',...
                    covvs25(1,1), covvs75(1,1), covvs25(1,2), covvs75(1,2), covvs25(1,3), covvs75(1,3));
%fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', '$-cov[\tilde{v}_t, \Sigma (\tilde{r^n}-\tilde{\pi}-\tilde{g})_{t+j})]$',...
%                    covvSrn25(1,1), covvSrn75(1,1), covvSrn25(1,2), covvSrn75(1,2), covvSrn25(1,3), covvSrn75(1,3));
fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', ' $cov[\tilde{v}_t, \Sigma (\tilde{r}^n-\tilde{\pi})_{t+j})]$',...
                    covvSr25(1,1), covvSr75(1,1), covvSr25(1,2), covvSr75(1,2), covvSr25(1,3), covvSr75(1,3));
    
fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', ' $cov(\tilde{v}_t, \Sigma \tilde{g}_{t+j})$',...
                    covvSg25(1,1), covvSg75(1,1), covvSg25(1,2), covvSg75(1,2), covvSg25(1,3), covvSg75(1,3));                
fprintf(vdecompq_ID,'\\hline \n');
fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', ' $-cov(\tilde{v}_t, \Sigma \tilde{r}^n_{t+j})$',...
                    -covvSrn25(1,1), -covvSrn75(1,1), -covvSrn25(1,2), -covvSrn75(1,2), -covvSrn25(1,3), -covvSrn75(1,3));
fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f & %8.2f \\\\ \n', ' $cov(\tilde{v}_t, \Sigma \tilde{\pi}_{t+j})$',...
                    covvSpi25(1,1), covvSpi75(1,1), covvSpi25(1,2), covvSpi75(1,2), covvSpi25(1,3), covvSpi75(1,3));
fprintf(vdecompq_ID,'\\hline \n');
fprintf(vdecompq_ID,'%99.99s & %8.2f & %8.2f & %8.2f  & %8.2f & %8.2f & %8.2f \\\\ \n', ' $\sigma(\tilde{v}_t)$',...
                    sigmav25(1,1), sigmav75(1,1), sigmav25(1,2), sigmav75(1,2), sigmav25(1,3), sigmav75(1,3));
fprintf(vdecompq_ID,'\\end{tabular} \n');
%fprintf(vdecompq_ID, [caption ' \n']);
fprintf(vdecompq_ID,'\\end{center} \n');
%fprintf(vdecompq_ID,'\\end{table} \n');

if tex_files
    fclose(vdecompq_ID);
end

% plot terms of the value decomposition

if stdate == 1947;
    xtm = xl - mean(xl);
    sterm = xtm*(asv'*ImA*A)';
    rnterm = xtm*(arn'*ImA*A)';
    piterm = xtm*(api'*ImA*A)';
    gterm = xtm*(ag'*ImA*A)';
    rgterm = rnterm-piterm-gterm;
    vterm = xtm*av;
    
    fig_dec = figure;
    plot(yr_a(stind:end),(vterm),'linewidth',2);
    hold on
    plot(yr_a(stind:end), sterm,'linewidth',2);
    %plot(yr_a(stind:end),-(rgterm),'linewidth',2);
    plot(yr_a(stind:end),-(rnterm-piterm),'-','linewidth',2);
    plot(yr_a(stind:end),(gterm),'-','linewidth',2);
    %plot(stdate*[1;1],[-5;2],'--k');
    plot(yr_a(stind:end),0*yr_a(stind:end),'-k')
    %title('VAR value decomposition');
    %legend('v','s','-r','g','location','southwest')
    indx = find(yr_a==1972);
    text(yr_a(indx),vterm(indx-stind+1),'v','color',colors(1,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),sterm(indx-stind+1),'s','color',colors(2,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),-rnterm(indx-stind+1)+piterm(indx-stind+1),'-r','color',colors(3,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),gterm(indx-stind+1),'g','color',colors(4,:),'fontsize',16,'backgroundcolor','w');
    
    %text(yr_a(indx),-rgterm(indx-stind+1)+0.05,'g-r','color',colors(3,:),'fontsize',16,'backgroundcolor','w');
    axis([1945 2020 -inf inf]);
    xlabel('Date')
    ylabel('Log scale')
    print(fig_dec,'value_decomp_VAR.eps','-depsc');
    
    
    % plot terms of the filtered value decomposition
    
    xftm = xfl - mean(xfl);
    sterm = xftm*(asv'*ImA*A)';
    rnterm = xftm*(arn'*ImA*A)';
    piterm = xftm*(api'*ImA*A)';
    gterm = xftm*(ag'*ImA*A)';
    vterm = xftm*av;
    
    fig_fdec = figure;
    plot(yr_a(stind+3:end),(vterm),'linewidth',2);
    hold on
    plot(yr_a(stind+3:end), sterm,'linewidth',2);
    plot(yr_a(stind+3:end),-(rnterm-piterm),'-','linewidth',2);
    %plot(yr_a(stind+3:end),-(rnterm-piterm),'--','linewidth',2);
    %plot(yr_a(stind+3:end),(gterm),'-','linewidth',2);
    %plot(stdate*[1;1],[-5;2],'--k');
    plot(yr_a(stind+3:end),0*yr_a(stind+3:end),'-k')
    %title('VAR value decomposition');
    indx = find(yr_a==1979);
    text(yr_a(indx),vterm(indx-stind+1-3),'v','color',colors(1,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),sterm(indx-stind+1-3),'s','color',colors(2,:),'fontsize',16,'backgroundcolor','w');
    text(yr_a(indx),-rnterm(indx-stind+1-3)+piterm(indx-stind+1-3),'-r','color',colors(3,:),'fontsize',16,'backgroundcolor','w');
    %text(yr_a(indx),gterm(indx-stind+1-3),'g','color',colors(4,:),'fontsize',16,'backgroundcolor','w');
    %text(yr_a(indx),-rgterm(indx-stind+1-3),'g-r','color',colors(3,:),'fontsize',16,'backgroundcolor','w');
    axis([1950 2020 -inf inf]);
    xlabel('Date')
    ylabel('Log scale')
    print(fig_fdec,'value_decomp_VAR_filtered.eps','-depsc');
    
end;